/* WiiJunker */

#import <Cocoa/Cocoa.h>
#include <stdio.h>
#import "Unscrambler.h"

@interface WiiJunker : NSObject
{
    IBOutlet NSButton *apply;
    IBOutlet NSTextField *gameName;
    IBOutlet NSTextField *gameRegion;
    IBOutlet NSButton *open;
    IBOutlet NSButton *patch;
    IBOutlet NSTextField *pathField;
    IBOutlet NSPopUpButton *regionPopUp;
    IBOutlet NSTextField *updateField;
	IBOutlet NSTextField *infoField;
	IBOutlet NSProgressIndicator *spinner;
	IBOutlet NSWindow *window;
	
	IBOutlet NSButton *burn;
	BOOL burning, unscrambling;
	
	FILE *iso;
	NSString *path;
	
	Unscrambler *unsc;
	IBOutlet NSTextField *unscISOField;
	IBOutlet NSTextField *unscStatus;
	IBOutlet NSProgressIndicator *unscProgress;
	IBOutlet NSWindow *unscWindow;
	NSString *unscramblingISOPath;
	
	
	
}

+ (id)getInstance;

- (void)reset;
- (IBAction)openISO:(id)sender;
- (void)checkType;
- (BOOL)isWiiFile;
- (BOOL)validateSize;

- (void)unscStart;
- (void)showUnscProgress;
- (void)unscThread;
- (void)updateProgress:(float)value andStatus:(NSString*)status;
- (void)unscFinish;
- (void)unscFailedWithError:(NSString *)err;
- (IBAction)abortUnscrambler:(id)sender;

- (void)loadInfo;
- (IBAction)burn:(id)sender;

- (NSString *)getGameName;
- (NSString *)getGameRegion;
- (int)getRegionCode;
- (BOOL)includesUpdate;



- (void)setRegion:(int) regionCode;
- (void)patchUpdate;
- (IBAction)applyChanges:(id)sender;


@end
